"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require("immutable");

var _immutable2 = _interopRequireDefault(_immutable);

var _immutable3 = require("./immutable");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Given an array of results ({joinValues: Array, value: Any}), provides a
 * method `get(joinValues)` that returns all values that have the same
 * `joinValues`.
 *
 * All results and the arguments provided to `get()` should have the same
 * length of `joinValues`.
 */
var JoinMap = function () {
    function JoinMap(results) {
        _classCallCheck(this, JoinMap);

        this._results = (0, _immutable3.toListMap)(results, function (result) {
            return [_immutable2.default.fromJS(result.joinValues), result.value];
        });
    }

    _createClass(JoinMap, [{
        key: "get",
        value: function get(joinValues, defaultValue) {
            return this._results.get(_immutable2.default.fromJS(joinValues), defaultValue);
        }
    }]);

    return JoinMap;
}();

exports.default = JoinMap;
//# sourceMappingURL=JoinMap.js.map