"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RootJoinType = exports.JoinType = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.execute = execute;
exports.many = many;
exports.single = single;
exports.extract = extract;
exports.field = field;

var _lodash = require("lodash");

var _language = require("graphql/language");

var _graphql = require("graphql");

var _requests = require("./requests");

var _JoinMap = require("./JoinMap");

var _JoinMap2 = _interopRequireDefault(_JoinMap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function execute(root, query) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    var request = (0, _requests.requestFromGraphqlDocument)((0, _language.parse)(query), root, options.variables);
    return executeRequest(root, request);
}

function executeRequest(root, request) {
    return Promise.resolve(root.fetch(request)).then(function (result) {
        return result[0].value;
    });
}

function many() {
    var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var target = _ref.target;
    var select = _ref.select;
    var join = _ref.join;
    var args = _ref.args;

    return new Relationship({
        target: target,
        select: select,
        join: join,
        args: args,
        processResults: function processResults(x) {
            return x;
        },
        wrapType: function wrapType(type) {
            return new _graphql.GraphQLList(type);
        }
    });
}

function single() {
    var _ref2 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var target = _ref2.target;
    var select = _ref2.select;
    var join = _ref2.join;
    var args = _ref2.args;

    return new Relationship({
        target: target,
        select: select,
        join: join,
        args: args,
        processResults: singleValue,
        wrapType: function wrapType(type) {
            return type;
        }
    });
}

function singleValue(values) {
    if (values.length === 0) {
        return null;
    } else if (values.length === 1) {
        return values[0];
    } else {
        throw new Error("TODO");
    }
}

var RelationshipResults = function () {
    function RelationshipResults(options) {
        _classCallCheck(this, RelationshipResults);

        this._results = new _JoinMap2.default(options.results);
        this._processResults = options.processResults;
        this._parentJoinKeys = options.parentJoinKeys;
    }

    _createClass(RelationshipResults, [{
        key: "get",
        value: function get(parent) {
            var parentJoinValues = this._parentJoinValues(parent);
            var values = this._results.get(parentJoinValues, []);
            return this._processResults(values);
        }
    }, {
        key: "_parentJoinValues",
        value: function _parentJoinValues(parent) {
            return this._parentJoinKeys.map(function (joinField) {
                return parent[joinField];
            });
        }
    }]);

    return RelationshipResults;
}();

var Relationship = function () {
    function Relationship(options) {
        _classCallCheck(this, Relationship);

        this._target = options.target;
        this._select = options.select;
        this._join = options.join || {};
        this.args = options.args || {};
        this._processResults = options.processResults;
        this._wrapType = options.wrapType;
        this._parentJoinKeys = (0, _lodash.map)(this._join, function (childKey, parentKey) {
            return "_graphjoiner_joinToChildrenKey_" + parentKey;
        });
    }

    _createClass(Relationship, [{
        key: "parentJoinSelections",
        value: function parentJoinSelections(parent) {
            var fields = parent.fields();
            return (0, _lodash.zip)((0, _lodash.map)(this._join, function (childKey, parentKey) {
                return parentKey;
            }), this._parentJoinKeys).map(function (_ref3) {
                var _ref4 = _slicedToArray(_ref3, 2);

                var fieldName = _ref4[0];
                var key = _ref4[1];
                return (0, _requests.createRequest)({
                    field: fields[fieldName],
                    key: key
                });
            });
        }
    }, {
        key: "fetch",
        value: function fetch(request, selectParent) {
            var _this = this;

            var joinFields = this._target.joinFields();
            var childRequest = _extends({}, request, {
                joinSelections: (0, _lodash.map)(this._join, function (childKey) {
                    return (0, _requests.createRequest)({
                        field: joinFields[childKey],
                        key: "_graphjoiner_joinToParentKey_" + childKey
                    });
                })
            });
            return Promise.resolve(this._select(request.args, selectParent)).then(function (select) {
                return _this._target.fetch(childRequest, select);
            }).then(function (results) {
                return new RelationshipResults({
                    results: results,
                    parentJoinKeys: _this._parentJoinKeys,
                    processResults: _this._processResults
                });
            });
        }
    }, {
        key: "toGraphQLField",
        value: function toGraphQLField() {
            var _this2 = this;

            // TODO: differentiate between root and non-root types properly
            var resolve = Object.keys(this._join).length !== 0 ? resolveField : function (source, args, context, info) {
                var request = (0, _requests.requestFromGraphqlAst)(info.fieldASTs[0], _this2._target, _this2, info.variableValues, info.fragments);
                return _this2.fetch(request, null).then(function (results) {
                    return results.get([]);
                });
            };
            return {
                type: this._wrapType(this._target.toGraphQLType()),
                resolve: resolve,
                args: this.args
            };
        }
    }]);

    return Relationship;
}();

function extract(relationship, fieldName) {
    return new Relationship({
        target: new ScalarJoinType(relationship._target, fieldName),
        processResults: relationship._processResults,
        wrapType: relationship._wrapType,
        select: relationship._select,
        join: relationship._join,
        args: relationship.args
    });
}

var ScalarJoinType = function () {
    function ScalarJoinType(target, fieldName) {
        _classCallCheck(this, ScalarJoinType);

        this._target = target;
        this._fieldName = fieldName;
    }

    _createClass(ScalarJoinType, [{
        key: "fields",
        value: function fields() {
            if (this._field instanceof Relationship) {
                return this._field._target.fields();
            } else {
                return {};
            }
        }
    }, {
        key: "joinFields",
        value: function joinFields() {
            return this._target.joinFields();
        }
    }, {
        key: "fetch",
        value: function fetch(request, select) {
            var _this3 = this;

            var fieldRequest = (0, _requests.createRequest)({
                key: this._fieldName,
                field: this._field,
                selections: request.selections,
                context: request.context
            });
            return this._target.fetch(_extends({}, request, { selections: [fieldRequest] }), select).then(function (results) {
                return results.map(function (result) {
                    return {
                        value: result.value[_this3._fieldName],
                        joinValues: result.joinValues
                    };
                });
            });
        }
    }, {
        key: "toGraphQLType",
        value: function toGraphQLType() {
            return this._field.toGraphQLField().type;
        }
    }, {
        key: "_field",
        get: function get() {
            return this._target.fields()[this._fieldName];
        }
    }]);

    return ScalarJoinType;
}();

var JoinType = exports.JoinType = function () {
    function JoinType(options) {
        _classCallCheck(this, JoinType);

        this._name = options.name;
        this.fetchImmediates = options.fetchImmediates;
        this._generateFields = options.fields;
        this._fields = null;
    }

    _createClass(JoinType, [{
        key: "fields",
        value: function fields() {
            if (this._fields === null) {
                // TODO: add name to field definitions?
                this._fields = this._generateFields();
            }
            return this._fields;
        }
    }, {
        key: "joinFields",
        value: function joinFields() {
            return this.fields();
        }
    }, {
        key: "fetch",
        value: function fetch(request, select) {
            var _this4 = this;

            var fields = this.fields();

            var _partition = (0, _lodash.partition)(request.selections, function (selection) {
                return selection.field instanceof Relationship;
            });

            var _partition2 = _slicedToArray(_partition, 2);

            var relationshipSelections = _partition2[0];
            var requestedImmediateSelections = _partition2[1];


            var joinToChildrenSelections = (0, _lodash.flatMap)(relationshipSelections, function (selection) {
                return selection.field.parentJoinSelections(_this4);
            });
            var immediateSelections = (0, _lodash.uniqBy)(requestedImmediateSelections.concat(request.joinSelections).concat(joinToChildrenSelections), "key");
            return Promise.resolve(this.fetchImmediates(immediateSelections, select)).then(function (results) {
                return Promise.all((0, _lodash.map)(relationshipSelections, function (fieldRequest) {
                    return fieldRequest.field.fetch(fieldRequest, select).then(function (children) {
                        results.forEach(function (result) {
                            result[fieldRequest.key] = children.get(result);
                        });
                    });
                })).then(function () {
                    return results.map(function (result) {
                        return {
                            value: (0, _lodash.fromPairs)(request.selections.map(function (selection) {
                                return [selection.key, result[selection.key]];
                            })),
                            joinValues: request.joinSelections.map(function (selection) {
                                return result[selection.key];
                            })
                        };
                    });
                });
            });
        }
    }, {
        key: "toGraphQLType",
        value: function toGraphQLType() {
            var _this5 = this;

            if (!this._graphQLType) {
                this._graphQLType = new _graphql.GraphQLObjectType({
                    name: this._name,
                    fields: function fields() {
                        return (0, _lodash.mapValues)(_this5.fields(), function (field) {
                            return field.toGraphQLField();
                        });
                    }
                });
            }
            return this._graphQLType;
        }
    }]);

    return JoinType;
}();

function field(options) {
    return _extends({}, options, {
        toGraphQLField: function toGraphQLField() {
            return {
                type: options.type,
                resolve: resolveField
            };
        }
    });
};

function resolveField(source, args, context, info) {
    return source[(0, _requests.requestedFieldKey)(info.fieldASTs[0])];
}

var RootJoinType = exports.RootJoinType = function (_JoinType) {
    _inherits(RootJoinType, _JoinType);

    function RootJoinType(options) {
        _classCallCheck(this, RootJoinType);

        return _possibleConstructorReturn(this, (RootJoinType.__proto__ || Object.getPrototypeOf(RootJoinType)).call(this, _extends({}, options, {
            fetchImmediates: function fetchImmediates() {
                return [{}];
            }
        })));
    }

    return RootJoinType;
}(JoinType);
//# sourceMappingURL=index.js.map